<script setup lang="ts">
import DeleteModal from "../modals/DeleteModal.vue";
import type { ApiTokenOut } from "@/client/types.gen.ts";
import dayjs from "dayjs";

const props = defineProps<{
  modalId: string;
  token?: ApiTokenOut;
  backModalId?: string;
}>();

const emit = defineEmits<{
  (e: "confirm-delete", tokenId: string): void;
}>();

function deleteToken() {
  if (props.token != undefined) {
    emit("confirm-delete", props.token.token_id);
    window._paq?.push(["trackEvent", "Delete", "api token"]);
  }
}
</script>

<template>
  <delete-modal
    :modal-id="props.modalId"
    :back-modal-id="props.backModalId"
    delete-type="Api Token"
    :disabled="props.token == undefined"
    @confirm-delete="deleteToken"
  >
    <template #body>
      <div class="mb-3">
        Are you sure you want to delete the API token
        <strong v-if="props.token">{{ props.token.name }}</strong
        >?
        <ul v-if="token">
          <li>
            Created at:
            {{ dayjs.unix(token.created_at).format("MMM DD, YYYY HH:mm:ss") }}
          </li>
          <li v-if="token.expires_at">
            Expires at:
            {{ dayjs.unix(token.expires_at).format("MMM DD, YYYY") }}
          </li>
          <li>
            Last used:
            <span v-if="token.last_used">{{
              dayjs.unix(token.last_used).format("MMM DD, YYYY HH:mm:ss")
            }}</span
            ><span v-else class="fa-italic">Never</span>
          </li>
          <li>Scopes: {{ token.scopes.join(", ") }}</li>
        </ul>
        <b>You can't access the API with this token anymore.</b>
      </div>
    </template>
  </delete-modal>
</template>

<style scoped></style>
